-- MAKE A TEMPORARY COPY OF THE OBSERVATIONS TABLE THAT HAS THE RA AND
-- DEC PROPERLY DONE

-- if the table exists, drop it so we can reload it
DROP TEMPORARY TABLE IF EXISTS newobs2;

--DROP TEMPORARY TABLE IF EXISTS temptab;

SET @ngpra=192.859508, @ngpdec=27.128336, @ascnode=32.932; -- base coords for galactic coord transformation.

-- CREATE TEMPORARY TABLE newobs2 LIKE observations;
-- 
-- ALTER TABLE newobs2
--   ADD COLUMN rajd (raj_hour+raj_minute/60.+raj_second/3600.)*15 

--CREATE TEMPORARY TABLE newobs2
--  SELECT pulsar_name,filename,raj_hour, raj_minute, raj_second, decj_degree, decj_minute, decj_second,
--        (raj_hour+raj_minute/60.+raj_second/3600.)*15 as rajd,
--        case when pulsar_name like "%-%" then -1.*(abs(decj_degree)+decj_minute/60.+decj_second/3600.)
--             when (decj_degree<0.)   then -1.*(abs(decj_degree)+decj_minute/60.+decj_second/3600.)
--             else abs(decj_degree)+decj_minute/60.+decj_second/3600. end as decjd,
--        dm, period, bw, cnfg, data_loc, data_type, freq, inst, MJD, npol, nchan, nbin, nsub,
--        rcvr, site, file_size_bytes, length, obsrvr, date, ut, tsamp, nbeam
--  FROM observations;	
CREATE TEMPORARY TABLE newobs2
  SELECT *,
        (raj_hour+raj_minute/60.+raj_second/3600.)*15 as rajd,
        case when pulsar_name like "%-%" then -1.*(abs(decj_degree)+decj_minute/60.+decj_second/3600.)
             when (decj_degree<0.)   then -1.*(abs(decj_degree)+decj_minute/60.+decj_second/3600.)
             else abs(decj_degree)+decj_minute/60.+decj_second/3600. end as decjd
  FROM observations;	

INSERT INTO TABLE newobs2 (gl1,gb1)
 SELECT glnew, gbnew
 FROM newobs2
 WHERE case when degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode > 0 
         then degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode
	 else degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode + 360. end case as glnew,
	(degrees( asin( cos(radians(decjd))*cos(radians(@ngpdec))*cos(radians(rajd-@ngpra)) + sin(radians(decjd))*sin(radians(@ngpdec))))) ) as gbnew;

    

--        case when degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode > 0 
--	     then degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode
--	     else degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode + 360. end as gl,
--	(degrees( asin( cos(radians(decjd))*cos(radians(@ngpdec))*cos(radians(rajd-@ngpra)) + sin(radians(decjd))*sin(radians(@ngpdec))))) as gb
--
--  FROM observations;	


-- version of mysql is <4.1 so cannot use CREATE ... LIKE ...
--CREATE TEMPORARY TABLE temptab
--   SELECT  pulsar_name,filename,raj_hour, raj_minute, raj_second, decj_degree, decj_minute, decj_second, 
--        (raj_hour+raj_minute/60.+raj_second/3600.)*15 as rajd,
--        case when pulsar_name like "%-%" then -1.*(abs(decj_degree)+decj_minute/60.+decj_second/3600.)
--             when (decj_degree<0.)   then -1.*(abs(decj_degree)+decj_minute/60.+decj_second/3600.)
--             else abs(decj_degree)+decj_minute/60.+decj_second/3600. end as decjd,
--         dm, period, bw, cnfg, data_loc, data_type, freq, inst, MJD, npol, nchan, nbin, nsub, 
--	 rcvr, site, file_size_bytes, length, obsrvr, date, ut, tsamp, nbeam
--   FROM observations;
--
--SET @ngpra=192.859508, @ngpdec=27.128336, @ascnode=32.932; -- base coords for galactic coord transformation.
--
--CREATE TEMPORARY TABLE newobs
--   SELECT *,
--        case when degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode > 0 
--	     then degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode
--	     else degrees( atan2( ( sin(radians(decjd))*cos(radians(@ngpdec)) - cos(radians(decjd))*sin(radians(@ngpdec))*cos(radians(rajd-@ngpra)) ) , ( cos(radians(decjd))*sin(radians(rajd-@ngpra)) ) ) ) + @ascnode + 360. end as gl,
--	(degrees( asin( cos(radians(decjd))*cos(radians(@ngpdec))*cos(radians(rajd-@ngpra)) + sin(radians(decjd))*sin(radians(@ngpdec))))) as gb
--    FROM temptab
--;

--DROP TEMPORARY TABLE IF EXISTS temptab;
